const { api } = require("../../utils/api")
import { getNavLayout } from '../../utils/util'; // 引入工具函数
// pages/index/info.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    id:'',
    farms:[],
    weather:null,
    list:[],
    backButtonStyle:''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.setData({id:options.id})
    this.init()
  },

  init(){
    const tmp = wx.getStorageSync('weather')
    if(tmp){
      this.setData({weather:tmp})
    }
    const layout = getNavLayout();
    this.setData({
      backButtonStyle: layout.containerStyle
    });
  },

  fetchInfo(){
    const data ={id: this.data.id}
    api('/plant/detail','GET',data).then(res => {
      if (res.code === 200){
        const tmp = res.data
        if (tmp.imgList.length >0 ){
          tmp.pic = tmp.imgList[0].url
          tmp.picList = tmp.imgList.map(sub => sub.url)
        }
        
        tmp.todayCares.map(e => e.period = tmp.carePlans.find(sub => sub.name === e.name).period)
        this.setData({info:res.data})
      }
    })

    const params =  {current:1,pageSize:999,id:this.data.id,keyword:''}
    api('/plant/grow/recordList','POST',params,'json').then(res => {
      if (res.code === 200){
        const tmps =res.data.list.map(e => {
          e.createdAtStr = e.createdAtStr.substring(0,10)
          return e
        })
        this.setData({list:tmps})
      }
    })
  },

  goRecord(e){
    const index = e.currentTarget.dataset.index
    wx.navigateTo({
      url: '../garden/record?id='+this.data.id +"&current="+index,
    })
  },

  goPreview(e){
    const index = e.detail.index
    const currentUrl = this.data.info.picList[index]
    const list = this.data.info.picList
    wx.previewImage({
      current: currentUrl, // 当前显示图片的http链接
      urls: list// 需要预览的图片http链接列表
    })
  },

  make(e){
    const item = e.currentTarget.dataset.item
    if (item.status === 2){
      wx.showModal({
        content: '已完成',
      })
      return
    }
    const data = {id:item.id,plantId:item.plantId,  name:item.name,remark:'测试',status:2}
    api('/plant/makeCare','POST',data,'json').then(res => {
      if (res.code === 200){
        wx.showToast({
          icon:'success',
          title: res.msg,
        })
        this.fetchInfo()
      }
    })
  },

  goEdit(){
    wx.navigateTo({
      url: '../index/edit?id=' + this.data.id,
    })
  },

  goBack(){
    wx.navigateBack()
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    this.fetchInfo()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})